#!/usr/bin/env node


'use strict';

var _internalIp = require('internal-ip');

var _internalIp2 = _interopRequireDefault(_internalIp);

var _clor = require('clor');

var _clor2 = _interopRequireDefault(_clor);

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

var _package = require('../package');

var _package2 = _interopRequireDefault(_package);

var _log = require('../lib/log');

var _log2 = _interopRequireDefault(_log);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var argv = _yargs2.default.usage('Usage: $0 [options]').option('uiPort', {
  describe: 'Port you want the UI to listen to. Defaults to 80'
}).option('dataDir', {
  describe: "Top directory you want Homie's data to be stored in. Defaults to <homeDir>/.homie"
}).option('logLevel', {
  describe: 'Minimum log level for console output'
}).help().locale('en').argv;

// Font: Dr Pepper
var homieStyled = _clor2.default.magenta(' _____           _        _____\n|  |  |___ _____|_|___   |   __|___ ___ _ _ ___ ___\n|     | . |     | | -_|  |__   | -_|  _| | | -_|  _|\n|__|__|___|_|_|_|_|___|  |_____|___|_|  \\_/|___|_|\n');

_log2.default.print(homieStyled);
_log2.default.print(_clor2.default.magenta('Version ').bold.magenta(_package2.default.version).line());

_log2.default.print(_clor2.default.magenta('See ').underline.magenta('https://git.io/homie-server#configuration').line());

_log2.default.print(_clor2.default.magenta('Homie server IP is ').bold.underline.magenta(_internalIp2.default.v4())());
_log2.default.print(_clor2.default.magenta("Make sure this IP won't change over time").line());

(0, _index2.default)({
  uiPort: argv.uiPort,
  dataDir: argv.dataDir,
  logLevel: argv.logLevel
});