'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _events = require('events');

var _mqtt = require('mqtt');

var _mqtt2 = _interopRequireDefault(_mqtt);

var _pauseable = require('pauseable');

var _pauseable2 = _interopRequireDefault(_pauseable);

var _dispatcher = require('../dispatcher');

var _dispatcher2 = _interopRequireDefault(_dispatcher);

var _mqttParser = require('../mqtt-parser');

var _mqttParser2 = _interopRequireDefault(_mqttParser);

var _log = require('../log');

var _log2 = _interopRequireDefault(_log);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MqttClient = function (_EventEmitter) {
  (0, _inherits3.default)(MqttClient, _EventEmitter);

  function MqttClient(options) {
    (0, _classCallCheck3.default)(this, MqttClient);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(MqttClient).call(this));

    _this.options = options;
    _this.connected = false;
    return _this;
  }

  (0, _createClass3.default)(MqttClient, [{
    key: 'start',
    value: function start() {
      var _this2 = this;

      this.client = _mqtt2.default.connect(this.options.url, {
        clientId: this.options.clientId ? this.options.clientId : 'HomieServer-' + Math.random().toString(16).substr(2, 8),
        username: this.options.username,
        password: this.options.password
      });

      _dispatcher2.default.on('ready', function () {
        _pauseable2.default.resume(_this2.client);
      });

      this.client.on('connect', function () {
        _this2.connected = true;
        if (!_dispatcher2.default.isReady()) {
          _pauseable2.default.pause(_this2.client);
        }
        _this2.client.subscribe('devices/#');
        _this2.emit('connection');
        _log2.default.info('Connected to the MQTT broker');
      });

      var disconnected = function disconnected() {
        if (_this2.connected) {
          // else this is triggered every few secs
          _this2.connected = false;
          _this2.emit('disconnection');
          _log2.default.error('Disconnected from the MQTT broker');
        }
      };

      this.client.on('offline', function () {
        disconnected();
      });

      this.client.on('close', function () {
        disconnected();
      });

      this.client.on('message', function (topic, message) {
        var parsed = _mqttParser2.default.parse(topic, message.toString());
        if (!parsed) {
          return;
        }

        _this2.emit('homieMessage', parsed);
      });
    }
  }, {
    key: 'publish',
    value: function publish(packet) {
      this.client.publish(packet.topic, packet.payload, {
        qos: packet.qos,
        retain: packet.retain
      });
    }
  }, {
    key: 'getConnectionStatus',
    value: function getConnectionStatus() {
      return this.connected;
    }
  }]);
  return MqttClient;
}(_events.EventEmitter);

exports.default = MqttClient;