'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _events = require('events');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Dispatcher = function (_EventEmitter) {
  (0, _inherits3.default)(Dispatcher, _EventEmitter);

  function Dispatcher() {
    (0, _classCallCheck3.default)(this, Dispatcher);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Dispatcher).call(this));

    _this.entities = {};
    _this.ready = false;
    return _this;
  }

  (0, _createClass3.default)(Dispatcher, [{
    key: 'attach',
    value: function attach(name, entity) {
      this.entities[name] = entity;
    }
  }, {
    key: 'start',
    value: function start() {
      var _this2 = this;

      this.entities.mqtt.on('homieMessage', function (parsed) {
        _this2.emit('homieMessage', parsed);
      });

      this.entities.infrastructure.on('update', function (update) {
        _this2.entities.gui.emitToWebsocket('infrastructureUpdate', update);
      });

      // WebSocket connect handler

      this.entities.gui.on('connection', function (socket) {
        socket.emit('infrastructure', _this2.entities['infrastructure'].getRepresentation());
        socket.emit('mqttClientStatus', _this2.entities.mqtt.getConnectionStatus());

        _this2.entities.mqtt.on('connection', function () {
          _this2.entities.gui.emitToWebsocket('mqttClientStatus', true);
        });

        _this2.entities.mqtt.on('disconnection', function () {
          _this2.entities.gui.emitToWebsocket('mqttClientStatus', false);
        });

        socket.on('setProperty', function (data) {
          _this2.entities.infrastructure.sendProperty(data);
        });
      });

      this.emit('ready');
      this.ready = true;
    }
  }, {
    key: 'publishMqttMessage',
    value: function publishMqttMessage(packet) {
      this.entities.mqtt.publish(packet);
    }
  }, {
    key: 'isReady',
    value: function isReady() {
      return this.ready;
    }
  }]);
  return Dispatcher;
}(_events.EventEmitter);

exports.default = new Dispatcher();