'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _yamljs = require('yamljs');

var _yamljs2 = _interopRequireDefault(_yamljs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _events = require('events');

var _mqttParser = require('./mqtt-parser');

var _property = require('./validators/property');

var _property2 = _interopRequireDefault(_property);

var _devices = require('./storage/devices');

var _devices2 = _interopRequireDefault(_devices);

var _log = require('./log');

var _log2 = _interopRequireDefault(_log);

var _dispatcher = require('./dispatcher');

var _dispatcher2 = _interopRequireDefault(_dispatcher);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Infrastructure = function (_EventEmitter) {
  (0, _inherits3.default)(Infrastructure, _EventEmitter);

  function Infrastructure(options) {
    (0, _classCallCheck3.default)(this, Infrastructure);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Infrastructure).call(this));

    _this.dataDir = options.dataDir;
    return _this;
  }

  (0, _createClass3.default)(Infrastructure, [{
    key: 'start',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        var _this2 = this;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', new _promise2.default(function (resolve, reject) {
                  _this2._config = _yamljs2.default.load(_path2.default.join(_this2.dataDir, '/infrastructure.yml'));
                  _this2._representation = { devices: {} };
                  _this2._representation.groups = _this2._config.groups;

                  _this2._devicesStorage = new _devices2.default({ dataDir: _this2.dataDir });

                  _this2._config.devices.forEach(function (device) {
                    var nodes = {};
                    device.nodes.forEach(function (node) {
                      var nodeId = node.id;
                      delete node.id;
                      node.state = {};
                      nodes[nodeId] = node;
                    });
                    _this2._representation.devices[device.id] = {
                      location: device.location,
                      color: device.color,
                      state: {
                        online: false
                      },
                      nodes: nodes
                    };
                  });

                  // If devices don't exist in db let's create them, otherwise populate object

                  (0, _keys2.default)(_this2._representation.devices).forEach(function () {
                    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(deviceId) {
                      var doc;
                      return _regenerator2.default.wrap(function _callee2$(_context2) {
                        while (1) {
                          switch (_context2.prev = _context2.next) {
                            case 0:
                              _context2.next = 2;
                              return _this2._devicesStorage.findDevice(deviceId);

                            case 2:
                              doc = _context2.sent;

                              if (doc) {
                                _context2.next = 7;
                                break;
                              }

                              return _context2.delegateYield(_regenerator2.default.mark(function _callee() {
                                var nodes;
                                return _regenerator2.default.wrap(function _callee$(_context) {
                                  while (1) {
                                    switch (_context.prev = _context.next) {
                                      case 0:
                                        nodes = {};

                                        (0, _keys2.default)(_this2._representation.devices[deviceId].nodes).forEach(function (nodeId) {
                                          nodes[nodeId] = _this2._representation.devices[deviceId].nodes[nodeId];
                                          delete nodes[nodeId].location;
                                          delete nodes[nodeId].name;
                                        });

                                        _context.next = 4;
                                        return _this2._devicesStorage.insertDevice({
                                          id: deviceId,
                                          state: _this2._representation.devices[deviceId].state,
                                          nodes: nodes
                                        });

                                      case 4:
                                      case 'end':
                                        return _context.stop();
                                    }
                                  }
                                }, _callee, _this2);
                              })(), 't0', 5);

                            case 5:
                              _context2.next = 9;
                              break;

                            case 7:
                              _this2._representation.devices[deviceId].state = doc.state;
                              (0, _keys2.default)(doc.nodes).forEach(function (nodeId) {
                                _this2._representation.devices[deviceId].nodes[nodeId].state = doc.nodes[nodeId].state;
                              });

                            case 9:
                            case 'end':
                              return _context2.stop();
                          }
                        }
                      }, _callee2, _this2);
                    })),
                        _this = _this2;
                    return function (_x) {
                      return ref.apply(_this, arguments);
                    };
                  }());

                  // Handle MQTT inputs

                  _dispatcher2.default.on('homieMessage', function () {
                    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(parsed) {
                      var online, signal, convertedValue;
                      return _regenerator2.default.wrap(function _callee3$(_context3) {
                        while (1) {
                          switch (_context3.prev = _context3.next) {
                            case 0:
                              if (!(parsed.type === _mqttParser.SET_NODE_PROPERTY)) {
                                _context3.next = 2;
                                break;
                              }

                              return _context3.abrupt('return');

                            case 2:
                              if (_this2._representation.devices[parsed.deviceId]) {
                                _context3.next = 5;
                                break;
                              }

                              _log2.default.debug('device ' + parsed.deviceId + ' not registered');
                              return _context3.abrupt('return');

                            case 5:
                              if (!(parsed.type === _mqttParser.DEVICE_PROPERTY)) {
                                _context3.next = 40;
                                break;
                              }

                              _context3.t0 = parsed.property.name;
                              _context3.next = _context3.t0 === 'ota' ? 9 : _context3.t0 === 'reset' ? 10 : _context3.t0 === 'online' ? 11 : _context3.t0 === 'name' ? 16 : _context3.t0 === 'signal' ? 20 : _context3.t0 === 'fwname' ? 25 : _context3.t0 === 'fwversion' ? 29 : _context3.t0 === 'localip' ? 33 : _context3.t0 === 'nodes' ? 37 : 38;
                              break;

                            case 9:
                              return _context3.abrupt('break', 39);

                            case 10:
                              return _context3.abrupt('break', 39);

                            case 11:
                              online = parsed.property.value === 'true';
                              _context3.next = 14;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: online });

                            case 14:
                              _log2.default.debug(parsed.deviceId + ' is ' + (online ? 'online' : 'offline'));
                              return _context3.abrupt('break', 39);

                            case 16:
                              _context3.next = 18;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: parsed.property.value });

                            case 18:
                              _log2.default.debug(parsed.deviceId + ' name is ' + parsed.property.value);
                              return _context3.abrupt('break', 39);

                            case 20:
                              signal = parseInt(parsed.property.value, 10);
                              _context3.next = 23;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: signal });

                            case 23:
                              _log2.default.debug(parsed.deviceId + ' signal is ' + signal + '%');
                              return _context3.abrupt('break', 39);

                            case 25:
                              _context3.next = 27;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: parsed.property.value });

                            case 27:
                              _log2.default.debug(parsed.deviceId + ' firmware name is ' + parsed.property.value);
                              return _context3.abrupt('break', 39);

                            case 29:
                              _context3.next = 31;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: parsed.property.value });

                            case 31:
                              _log2.default.debug(parsed.deviceId + ' firmware version is ' + parsed.property.value);
                              return _context3.abrupt('break', 39);

                            case 33:
                              _context3.next = 35;
                              return _this2._updateDeviceProperty({ deviceId: parsed.deviceId, property: parsed.property.name, value: parsed.property.value });

                            case 35:
                              _log2.default.debug(parsed.deviceId + ' IP is ' + parsed.property.value);
                              return _context3.abrupt('break', 39);

                            case 37:
                              return _context3.abrupt('break', 39);

                            case 38:
                              _log2.default.debug(parsed.deviceId + ' sent unknown device property', { propertyName: parsed.property.name, propertyValue: parsed.property.value });

                            case 39:
                              return _context3.abrupt('return');

                            case 40:
                              if (_this2._representation.devices[parsed.deviceId].nodes[parsed.nodeId]) {
                                _context3.next = 43;
                                break;
                              }

                              _log2.default.debug('node ' + parsed.nodeId + ' of device ' + parsed.deviceId + ' not registered');
                              return _context3.abrupt('return');

                            case 43:
                              if (_property2.default.canReceive(_this2._representation.devices[parsed.deviceId].nodes[parsed.nodeId].type, parsed.property.name, parsed.property.value)) {
                                _context3.next = 46;
                                break;
                              }

                              _log2.default.debug(parsed.deviceId + ' sent bad value', { nodeId: parsed.nodeId, property: parsed.property.name, value: parsed.property.value });
                              return _context3.abrupt('return');

                            case 46:
                              convertedValue = _property2.default.convertValue(_this2._representation.devices[parsed.deviceId].nodes[parsed.nodeId].type, parsed.property.name, parsed.property.value);
                              _context3.next = 49;
                              return _this2._updateNodeProperty({ deviceId: parsed.deviceId, nodeId: parsed.nodeId, property: parsed.property.name, value: convertedValue });

                            case 49:
                              _log2.default.debug('device ' + parsed.deviceId + ' node ' + parsed.nodeId + ' - ' + parsed.property.name + ' = ' + convertedValue);

                            case 50:
                            case 'end':
                              return _context3.stop();
                          }
                        }
                      }, _callee3, _this2);
                    })),
                        _this = _this2;
                    return function (_x2) {
                      return ref.apply(_this, arguments);
                    };
                  }());

                  resolve();
                }));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));
      return function start() {
        return ref.apply(this, arguments);
      };
    }()
  }, {
    key: '_updateDeviceProperty',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(options) {
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                this.emit('update', {
                  type: 'device',
                  deviceId: options.deviceId,
                  property: options.property,
                  value: options.value
                });
                this._representation.devices[options.deviceId].state[options.property] = options.value;
                _context5.next = 4;
                return this._devicesStorage.updateDeviceState({ id: options.deviceId, name: options.property, value: options.value });

              case 4:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));
      return function _updateDeviceProperty(_x3) {
        return ref.apply(this, arguments);
      };
    }()
  }, {
    key: '_updateNodeProperty',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(options) {
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                this.emit('update', {
                  type: 'node',
                  deviceId: options.deviceId,
                  nodeId: options.nodeId,
                  property: options.property,
                  value: options.value
                });
                this._representation.devices[options.deviceId].nodes[options.nodeId].state[options.property] = options.value;
                _context6.next = 4;
                return this._devicesStorage.updateNodeState({ deviceId: options.deviceId, nodeId: options.nodeId, name: options.property, value: options.value });

              case 4:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));
      return function _updateNodeProperty(_x4) {
        return ref.apply(this, arguments);
      };
    }()
  }, {
    key: 'sendProperty',
    value: function sendProperty(options) {
      var deviceId = options.deviceId;
      var nodeId = options.nodeId;
      var property = options.property;
      var value = options.value;
      var qos = options.qos || 2;
      var retain = options.retain || true;

      _dispatcher2.default.publishMqttMessage({
        topic: 'devices/' + deviceId + '/' + nodeId + '/' + property + '/set',
        payload: value.toString(),
        qos: qos,
        retain: retain
      });
    }
  }, {
    key: 'getRepresentation',
    value: function getRepresentation() {
      return this._representation;
    }
  }]);
  return Infrastructure;
}(_events.EventEmitter);

exports.default = Infrastructure;