'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _clor = require('clor');

var _clor2 = _interopRequireDefault(_clor);

var _os = require('os');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FATAL = 0;
var ERROR = 1;
var WARN = 2;
var INFO = 3;
var DEBUG = 4;

var Log = function () {
  function Log() {
    (0, _classCallCheck3.default)(this, Log);

    this.logLevel = INFO;
  }

  (0, _createClass3.default)(Log, [{
    key: 'setLogLevel',
    value: function setLogLevel(logLevel) {
      this.logLevel = logLevel;
    }
  }, {
    key: 'print',
    value: function print(text) {
      process.stdout.write(text + _os.EOL);
    }
  }, {
    key: 'log',
    value: function log(message, meta, type) {
      var output = new Date().toISOString();
      output += ' ' + this._getColoredType(type);
      output += ' ';
      output += undefined !== message ? message : '';
      if (meta && (0, _keys2.default)(meta).length) {
        (function () {
          output += _os.EOL;
          var stringify = (0, _stringify2.default)(meta, null, 2);
          var splitted = stringify.split('\n');
          splitted.forEach(function (line, index) {
            output += '  ' + line;
            if (index < splitted.length - 1) {
              output += _os.EOL;
            }
          });
        })();
      }
      this.print(output);
    }
  }, {
    key: 'fatal',
    value: function fatal(message, meta) {
      if (this.logLevel >= FATAL) {
        return this.log(message, meta, FATAL);
      }
    }
  }, {
    key: 'error',
    value: function error(message, meta) {
      if (this.logLevel >= ERROR) {
        return this.log(message, meta, ERROR);
      }
    }
  }, {
    key: 'warn',
    value: function warn(message, meta) {
      if (this.logLevel >= WARN) {
        return this.log(message, meta, WARN);
      }
    }
  }, {
    key: 'info',
    value: function info(message, meta) {
      if (this.logLevel >= INFO) {
        return this.log(message, meta, INFO);
      }
    }
  }, {
    key: 'debug',
    value: function debug(message, meta) {
      if (this.logLevel >= DEBUG) {
        return this.log(message, meta, DEBUG);
      }
    }
  }, {
    key: '_getColoredType',
    value: function _getColoredType(type) {
      switch (type) {
        case FATAL:
          return _clor2.default.inverse.bold.red('fatal:').toString();
        case ERROR:
          return _clor2.default.red('error:').toString();
        case WARN:
          return _clor2.default.yellow(' warn:').toString();
        case INFO:
          return _clor2.default.cyan(' info:').toString();
        case DEBUG:
          return _clor2.default.underline.white('debug:').toString();
        default:
          return '  log:';
      }
    }
  }]);
  return Log;
}();

exports.default = new Log();