'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _http = require('http');

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _socket = require('socket.io');

var _socket2 = _interopRequireDefault(_socket);

var _server = require('./server');

var _server2 = _interopRequireDefault(_server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GuiServer = function (_Server) {
  (0, _inherits3.default)(GuiServer, _Server);

  function GuiServer(options) {
    (0, _classCallCheck3.default)(this, GuiServer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(GuiServer).call(this, 'GUI'));

    _this.port = options.port;

    _this.app = (0, _express2.default)();
    _this.server = (0, _http.createServer)(_this.app);
    _this.websocket = (0, _socket2.default)(_this.server);

    _this.app.use(_express2.default.static(__dirname + '/../../public'));

    _this.app.get('/offline.html', function (req, res) {
      res.sendFile(_path2.default.resolve(__dirname + '/../../views/offline.html')); // path resolve else with relative path express might cry
    });

    _this.app.all('*', function (req, res) {
      res.sendFile(_path2.default.resolve(__dirname + '/../../views/index.html'));
    });

    _this.websocket.on('connection', function (socket) {
      _this.emit('connection', socket);
    });
    return _this;
  }

  (0, _createClass3.default)(GuiServer, [{
    key: 'start',
    value: function start() {
      var _this2 = this;

      return new _promise2.default(function (resolve, reject) {
        _this2.server.listen(_this2.port, function () {
          var host = _this2.server.address().address;
          var port = _this2.server.address().port;
          resolve({ host: host, port: port });
        }).on('error', function (err) {
          reject(err);
        });
      });
    }
  }, {
    key: 'emitToWebsocket',
    value: function emitToWebsocket(type, message) {
      this.websocket.emit(type, message);
    }
  }]);
  return GuiServer;
}(_server2.default);

exports.default = GuiServer;