'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _database = require('./database');

var _database2 = _interopRequireDefault(_database);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DevicesStorage = function (_Database) {
  (0, _inherits3.default)(DevicesStorage, _Database);

  function DevicesStorage(options) {
    (0, _classCallCheck3.default)(this, DevicesStorage);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(DevicesStorage).call(this, { dbName: 'devices', dataDir: options.dataDir }));
  }

  (0, _createClass3.default)(DevicesStorage, [{
    key: 'findDevice',
    value: function findDevice(id) {
      return (0, _get3.default)((0, _getPrototypeOf2.default)(DevicesStorage.prototype), 'db', this).findOneAsync({ _id: id });
    }
  }, {
    key: 'insertDevice',
    value: function insertDevice(options) {
      return (0, _get3.default)((0, _getPrototypeOf2.default)(DevicesStorage.prototype), 'db', this).insertAsync({
        _id: options.id,
        state: options.state,
        nodes: options.nodes
      });
    }
  }, {
    key: 'updateDeviceState',
    value: function updateDeviceState(options) {
      var changes = {};
      changes['state.' + options.name] = options.value; // {`${test}`: true} is not doable
      return (0, _get3.default)((0, _getPrototypeOf2.default)(DevicesStorage.prototype), 'db', this).updateAsync({ _id: options.id }, { $set: changes });
    }
  }, {
    key: 'updateNodeState',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(options) {
        var changes;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                changes = {};

                changes['nodes.' + options.nodeId + '.state.' + options.name] = options.value;
                return _context.abrupt('return', (0, _get3.default)((0, _getPrototypeOf2.default)(DevicesStorage.prototype), 'db', this).updateAsync({ _id: options.deviceId }, { $set: changes }));

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
      return function updateNodeState(_x) {
        return ref.apply(this, arguments);
      };
    }()
  }]);
  return DevicesStorage;
}(_database2.default);

exports.default = DevicesStorage;